define difNOpv (nrep = !charend('/')/
                dep = !charend('/') /
                stat = !charend ('/') /
                within = !charend('/') /
                compare = !charend('/') /
                categ = !charend ('/') /
                wgt = !charend('/') /
                rwgt = !charend('/') /
                cons = !charend('/')/
                infile = !charend('/')).


get file !infile /keep !dep !within !compare !wgt !concat(!rwgt,1) to !concat(!rwgt,!nrep) .



*** COMPUTE ESTIMATE ***.

weight by !wgt.
aggregate outfile = * 
   /break=!within !compare /stat=!stat(!dep).
exe.
casestovars /id=!within /index=!compare .

!let !n=!length(!categ).
!let !m=!LENGTH(!substr(!blanks(!n),2)).

!let !var=" ".
!do !a=1 !to !m.
!let !s=!LENGTH(!concat(!blanks(!a),' ')).
!do !b=!s !to !n.

!let !d=!substr(!categ,!a,1).
!let !e=!substr(!categ,!b,1).
compute !concat('stat',!d,'_',!e)=
        !concat('stat.',!d)-!concat('stat.',!e).
!let !var=!concat(!var,'stat',!d,'_',!e,' ').
!doend.
!doend.

VARSTOCASES  /MAKE stat FROM !var
 /INDEX = contrast(stat) /KEEP = !within /NULL = DROP.

save outile='c:\temp\all.sav'.



* REPLICATES.

!do !i= 1 !to !nrep.
get file !infile /keep !within !compare !wgt !concat(!rwgt,1) to !concat(!rwgt,!nrep) !dep).
weight by !concat(!rwgt,!i).

aggregate outfile = * 
   /break=!within !compare /stat=!stat(!dep).
exe.
casestovars /id=!within /index=!compare .

!let !n=!length(!categ).
!let !m=!LENGTH(!substr(!blanks(!n),2)).

!let !var=" ".
!do !a=1 !to !m.
!let !s=!LENGTH(!concat(!blanks(!a),' ')).
!do !b=!s !to !n.

!let !d=!substr(!categ,!a,1).
!let !e=!substr(!categ,!b,1).
compute !concat('stat',!d,'_',!e)=
        !concat('stat.',!d)-!concat('stat.',!e).
!let !var=!concat(!var,'stat',!d,'_',!e,' ').
!doend.
!doend.

VARSTOCASES  /MAKE statR FROM !var
 /INDEX = contrast(statR) /KEEP = !within /NULL = DROP.


save outile=!quote(!concat('c:\temp\',!dep,!i,'.sav')).
!doend.



*** COMBINE RESULTS ***.

get file =!quote(!concat('c:\temp\',!dep,'1','.sav')).

!Do !e = 2 !to !nrep.
add files file=* /file=!quote(!concat('c:\temp\',!dep,!e,'.sav')).
!Doend.

sort cases by !within CONTRAST.
match files file=* /table='c:\temp\all.sav' /by !within CONTRAST.
exec.



*** COMPUTE SAMPLING VARIANCE (U) ***.

compute var=(statr-stat)**2.
save outfile = 'c:\temp\regmod.sav'.

aggregate outfile=*/ break=!within contrast/ stat= mean(stat)/ var=sum(var).

compute var=!cons*var.



*** COMPUTE STANDARD ERROR ***.

compute se=sqrt(var).
exec.

formats stat (f8.3)/ SE (f10.6).
list cases/var= !within contrast stat se.

string contr (a3).
compute contr=substr(contrast,5,3).
casestovars /id=!within /index=contr /groupby=index /drop=contrast var.

!enddefine.