define REGnoPV (nrep = !charend('/')/
                ind = !charend('/') /
                dep = !charend('/') /
                grp = !charend('/') /
                wgt = !charend('/') /
                rwgt = !charend('/') /
                cons = !charend('/')/
                infile = !charend('/')).



get file !infile /keep !grp !wgt !concat(!rwgt,1) to !concat(!rwgt,!nrep) !dep !ind).
sort cases by !grp.       
save outfile='c:\temp\sort.sav'.


*** COMPUTE ESTIMATE ***.

     
split file by !grp.            
                              
weight by !wgt.

REGRESSION
  /DEPENDENT !dep
  /METHOD=ENTER !ind
  /OUTFILE=COVB('C:\temp\coef.sav') .
get file='C:\temp\coef.sav'.
select if (rowtype_='EST').
rename var(CONST_=b0).
VARSTOCASES  /MAKE stat FROM b0 !ind
 /INDEX = ind(stat) /KEEP = !grp /NULL = KEEP.

erase file='c:\temp\all.sav'.
sort cases by !grp ind.
save outfile='c:\temp\all.sav'.


* REPLICATES.

!do !i=1 !to !nrep.
get file='c:\temp\sort.sav'.

*sort cases by !grp.            
split file by !grp.            
                              
weight by !concat(!rwgt,!i).

REGRESSION
  /DEPENDENT !dep
  /METHOD=ENTER !ind
  /OUTFILE=COVB('C:\temp\coef.sav') .
get file='C:\temp\coef.sav'.
select if (rowtype_='EST').
rename var(CONST_=b0).
VARSTOCASES  /MAKE statR FROM b0 !ind
 /INDEX = ind(statR) /KEEP = !grp /NULL = KEEP.

save outfile=!quote(!concat('C:\temp\',!dep,!i,'.sav'))

!doend.



*** COMBINE RESULTS ***.

get file =!quote(!concat('C:\temp\',!dep,'1.sav')).

!Do !e = 2 !to !nrep.
add files file=* /file=!quote(!concat('C:\temp\',!dep,!e,'.sav')).
!Doend.

sort cases by !grp ind.

match files file=* /table='c:\temp\all.sav' /by !grp ind.
exec.



*** COMPUTE SAMPLING VARIANCE (U) ***.

compute var=(statr-stat)**2.
exec.

save outfile = 'c:\temp\regmod.sav'.

aggregate outfile=*/
	  break=!grp IND/ 
          stat= mean(stat)/
          var=sum(var).

compute var=!cons*var.




*** COMPUTE STANDARD ERROR ***.

compute se=sqrt(var).
exec.

formats stat (f8.3)/ SE (f10.6).
list cases/var= !grp ind stat se.

!enddefine.





