define univar (nrep = !charend('/')/
               stat = !charend('/')/
               dep = !charend('/') /
               grp = !charend('/') /
               wgt   = !charend('/') /
               rwgt   = !charend('/') /
               cons = !charend('/')/
               infile = !charend('/')).



get file !infile /keep !grp !wgt !concat(!rwgt,1) to !concat(!rwgt,!nrep) !dep).



*** COMPUTE ESTIMATE ***.

weight by !wgt.
aggregate outfile = !quote(!concat('c:\temp\',!stat,'_all.sav')) 
   /break=!grp /stat=!stat(!dep).
   
* REPLICATES.   

!do !i= 1 !to !nrep.
weight by !concat(!rwgt,!i).
aggregate outfile = !quote(!concat('C:\temp\',!stat,'_',!dep,!i,'.sav'))
   /break=!grp /statr=!stat(!dep).
!doend.



*** COMBINE RESULTS ***.

get file =!quote(!concat('C:\temp\',!stat,'_',!dep,'1.sav')).

!Do !e = 2 !to !nrep.
add files file=* /file=!quote(!concat('C:\temp\',!stat,'_',!dep,!e,'.sav')).
!Doend.

sort cases by !grp.
match files file=* /table=!quote(!concat('c:\temp\',!stat,'_all.sav')) /by !grp.
exec.



*** COMPUTE SAMPLING VARIANCE (U) ***.

compute var=(statr-stat)**2.
save outfile = 'c:\temp\regmod.sav'.

aggregate outfile=*/ break=!grp/ stat= mean(stat)/ var=sum(var).

compute var=!cons*var.



*** COMPUTE STANDARD ERROR ***.

compute se=sqrt(var).
exec.

formats stat (f8.3)/ SE (f10.6).
list cases/var= !grp stat se.

!enddefine.





